/**************************************************************

    Title:	FLIP -- An example program for a useful command.

    Purpose:	Provide a useful command for user to flip the
		direction of a text or dimension text.

    Author:	Kang, Hsin-Min.

	Revised at Apr 22, 1998 Include Japenese Text in SJIS codes
	Revised at Aug 05, 1998 Modify Japenese Messages.

    Copyright(c) 1995, 1998 TCAM Development House, Taipei.

    Command Alias Definition:

	FLIP, *CLOAD FLIP.TCL FLIP

    Usage:	Select Text/or Dimension?  <pick one>

**************************************************************/
// #include <tclcad.h>
// Resolve from tclcad.h
#define T_TEXT		6
#define T_DIM		9
#define FTEXT		0x40
#define FDIM		0x200
/*
	Dim.type & 0x0f
*/
#define DIMLINE 	0
#define DIMANG		1
#define DIMDIA		2
#define DIMRAD		3
#define DIMORD		4
#define DIMLEAD 	5
#define DIMCENLN	6

#define LoopForever	while(1)
#define big5()		(@tgftype==1)
#define gb()		(@tgftype==2)
#define sjis()		(@tgftype==5)

COMMAND Flip()
{
	ENTDATA data;
	POINT	dp;
	double	th, tlen, rb, rt;
	char	msg[80];

		      msg = "\nSelect Text or Dimension to Flip? ";
	if ( big5() ) msg = "\nпn½઺rΤث׼еϤ: ";
	if ( gb() )   msg = "\nѡȡҪתֻ߶ȱעͼԪ: ";
	if ( sjis() ) msg = "\n]eLXg͐@I:";

	LoopForever {
	    e1 = gete(msg,FDIM|FTEXT);
	    if ( userbrk(-1) )
		break;		// ^C to exit
	    if ( !ent_ok(e1) )
		break;		// Space bar to exit
	    data = ent_read(e1);
	    switch(ent_type(e1)) {
	      case T_TEXT:
		switch(data.text.tadj&0xf0) {	// Vertical Alignment
		  case 0x30:	data.text.tadj &= ~0xf0;	break;
		  case 0x00:	data.text.tadj |= 0x30; 	break;
		  case 0x10:	// Bottom
		    dp = data.text.height/3.,(rtd(data.text.angle+pi/2))A;
		    data.text.pbase+=dp;
		    data.text.tadj |=0x30;
		    if ( data.text.rad > 0 )
			data.text.rad += data.text.height/3.;
		    if ( data.text.rad < 0 )
			data.text.rad -= data.text.height/3.;
		    break;
		  case 0x20:	// Middle
		    dp = data.text.height/3.,(rtd(data.text.angle+pi/2))A;
		    data.text.pbase-=dp;
		    data.text.tadj |=0x30;
		    if ( data.text.rad > 0 )
			data.text.rad -= data.text.height/3.;
		    if ( data.text.rad < 0 )
			data.text.rad += data.text.height/3.;
		    break;
		}
		if ( (data.text.tadj&3)!=1 )	// If not center ?
		    data.text.tadj ^= 2;	// Left<->Right
		if ( data.text.rad != 0 ) {	// Circular Text ?
		    data.text.rad = -data.text.rad;
		    if ( data.text.width == 0 )
			data.text.width = 1;
		    rt = rb = abs(data.text.rad);
		    switch(data.text.tadj&0xf0) {
		      case 0x30:	// Been Changed to Top
			if ( data.text.rad > 0 )
			   rb -= data.text.height;
			else
			   rb += data.text.height;
			break;
		      case 0x00:	// Been Changed to Base
			if ( data.text.rad > 0 )
			   rt += data.text.height;
			else
			   rt -= data.text.height;
			break;
		    }
		    data.text.width *= rb/rt;
		}
		data.text.angle = mod(data.text.angle-pi,2*pi);
		ent_write(e1,data);
		continue;
	      case T_DIM:
		if ( (data.dim.flag&0x4008)==0x4008 ) {
		    data.dim.angle = mod(data.dim.angle-pi,2*pi);
		    ent_write(e1,data);
		    continue;
		}
		th = @dimtsize;
		if ( data.dim.iscale ) {
		    th *= data.dim.iscale;
		    th /= 256;	  // Calculate actual text size
		}
		dp = th,(rtd(data.dim.angle+pi/2))A;
		switch(data.dim.type&0x0f) {
		  case DIMANG:
		    if ( !(data.dim.flag&0x0c00) )
			continue;	// Not circular text in DIM
		  case DIMDIA:	case DIMRAD:
		  case DIMLINE:
		    if ( data.dim.flag&0x08 ) { // Centered Text ?
			data.dim.pt += dp;
			data.dim.angle = mod(data.dim.angle-pi,2*pi);
			ent_write(e1,data);
			continue;
		    }
		    s1 = @txtstyle;	@txtstyle=@dimtstyle;
		    s2 = @txtestyle;	@txtestyle=@dimestyle;
		    v1 = @txtheight;	@txtheight=th;
		    v2 = @txtwidthf;	@txtwidthf=@dimtwidth;
		    tlen = text_span(data.dim.str);
		    @txtstyle = s1;
		    @txtestyle = s2;
		    @txtheight = v1;
		    @txtwidthf = v2;
		    data.dim.pt += dp+P(tlen,(rtd(data.dim.angle))A);
		    data.dim.angle = mod(data.dim.angle-pi,2*pi);
		    ent_write(e1,data);
		    continue;
		}
	    }
	}
}
